Unit de84e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AME2E_p, DE00ES_p, DE04EQ_p, DE84EJ_p, UTDE21_p;

procedure de84e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; EPS :Extended; P :Extended;
                var YX :Array of Extended; var X :Extended; var H :Extended;
                var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var A :Array of Extended;
                var E1 :Array of Extended; var E2 :Array of Extended;
                var E3 :Array of Extended; var E4 :Array of Extended;
                var R :Array of Extended; var R0 :Array of Extended;
                var R1 :Array of Extended; var R2 :Array of Extended;
                var R3 :Array of Extended; var YD :Array of Extended;
                var IERR :Integer);

implementation

procedure de84e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; EPS :Extended; P :Extended;
                var YX :Array of Extended; var X :Extended; var H :Extended;
                var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var A :Array of Extended;
                var E1 :Array of Extended; var E2 :Array of Extended;
                var E3 :Array of Extended; var E4 :Array of Extended;
                var R :Array of Extended; var R0 :Array of Extended;
                var R1 :Array of Extended; var R2 :Array of Extended;
                var R3 :Array of Extended; var YD :Array of Extended;
                var IERR :Integer);
var
I,J :Integer;
C1,EPS1,EPSJ :Extended;
BULD,BULEX,BULHM :Boolean;
const
EPS0 :Extended = 1.0e-5;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190;
begin
IERR := 0;
EPS1 := EPS/32.e0;
EPSJ := EPS;
if ( EPS <  EPS0 ) 
 then goto _10;
EPSJ := EPS0;
_10:
BULD := True;
BULHM := False;
BULEX := False;
if ( JSTART ) < 0
 then goto _60
 else if ( JSTART ) > 0
       then goto _20
       else goto _80;
_20:
if ( JSTART =  1 ) 
 then goto _110;
if ( JSTART =  2 ) 
 then goto _30;
goto _90;
_30:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E1[(I-1)+(J-1)*M] := E2[(I-1)+(J-1)*M];
_40:
   end;
_50:
 end;
goto _100;
_60:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_70:
 end;
X := XP;
_80:
DE84EJ(F,X,YX,A,M,EPSJ,R1,R2);
_90:
C1 := H/4.e0;
AME2E(A,C1,M,E1,R,E3,E4);
if ( BULEX ) 
 then goto _110;
_100:
DE04EQ(M,E1,E2);
_110:
C1 := H/2.e0;
DE00ES(F,M,X,YX,H,A,E2,YD,R1,R2,R3);
DE00ES(F,M,X,YX,C1,A,E1,R0,R1,R2,R3);
DE00ES(F,M,X + C1,R0,C1,A,E1,R,R1,R2,R3);
for I:=1 to M do
 begin
  R1[I-1] := (R[I-1] - YD[I-1])/15.e0;
  C1 := Abs(R1[I-1]);
  if ( Abs(R[I-1]) >=  P ) 
   then C1 := C1/Abs(R[I-1]);
  if ( C1 >  EPS1 ) 
   then BULD := False;
  if ( C1 >=  EPS ) 
   then goto _150;
_120:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_130:
 end;
XP := X;
for I:=1 to M do
 begin
  YX[I-1] := R[I-1];
_140:
 end;
X := X + H;
if ( BULD ) 
 then H := H*2.e0;
goto _190;
_150:
if ( BULHM ) 
 then goto _180;
H := H/2.e0;
BUL := False;
BULEX := True;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E2[(I-1)+(J-1)*M] := E1[(I-1)+(J-1)*M];
_160:
   end;
_170:
 end;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _90;
H := Sign(HMIN,H);
BULHM := True;
BULEX := False;
goto _90;
_180:
IERR := 65;
UTDE21(IERR,84);
_190:
JSTART := 1;
if ( BULD ) 
 then JSTART := 2;
end;

end.
